// NOTE: it is recommended to use this even if you don't understand the
// following code.

#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

// input data
int N;
vector<int> C;
vector<int> P;

int main() {
    //  uncomment the following lines if you want to read/write from files
    //  ifstream cin("input.txt");
    //  ofstream cout("output.txt");

    cin >> N;
    C.resize(N);
    P.resize(N);
    for (int i = 0; i < N; i++) {
        // node i has color C[i]
        cin >> C[i];
    }
    for (int i = 1; i < N; i++) {
        // there is a link P[i] -> i
        // note: P[0] is undefined!
        cin >> P[i];
    }

    vector<int> counts(N);
    vector<int> revcounts(N);
    int sol = 0;
    int max_count = 0;
    for (int i = N - 1; i >= 0; i--) {
        int prev_count = counts[C[i]];
        if (prev_count > 0)
            revcounts[prev_count]--;
        int new_count = prev_count + 1;
        counts[C[i]] = new_count;
        revcounts[new_count]++;
        max_count = max(max_count, new_count);
        if (new_count == max_count)
            sol = max(sol, revcounts[new_count]);
    }

    cout << sol << endl;

    return 0;
}
