#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

using ii = pair<int, int>;

// input data
int N;
vector<int> C;
vector<int> P;

vector<vector<int>> adj;

vector<int> counts;

void dfs(int u) {
    counts[C[u]]++;
    for (int v : adj[u]) {
        dfs(v);
    }
}

int main() {
    //  uncomment the following lines if you want to read/write from files
    //  ifstream cin("input.txt");
    //  ofstream cout("output.txt");

    cin >> N;
    C.resize(N);
    P.resize(N);
    adj.resize(N);
    for (int i = 0; i < N; i++) {
        // node i has color C[i]
        cin >> C[i];
    }
    for (int i = 1; i < N; i++) {
        // there is a link P[i] -> i
        // note: P[0] is undefined!
        cin >> P[i];
        adj[P[i]].push_back(i);
    }

    counts.resize(N);
    int sol = 0;
    for (int i = 0; i < N; i++) {
        counts.assign(N, 0);
        dfs(i);
        int f = 1;
        int last = 0;
        for (int j = 1; j < N; j++) {
            if (counts[j] > counts[last]) {
                last = j;
                f = 1;
            } else if (counts[j] == counts[last]) {
                f++;
            }
        }
        sol = max(sol, f);
    }

    cout << sol << endl;
    return 0;
}
