#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

using ii = pair<int, int>;

// input data
int N;
vector<int> C;
vector<int> P;

vector<vector<int>> adj;

int sol = 1;

ii dfs(int u) {
    ii res = {C[u] == 0, C[u] == 1};
    for (int v : adj[u]) {
        ii child = dfs(v);
        res.first += child.first;
        res.second += child.second;
    }
    if (res.first == res.second)
        sol = max(sol, 2);
    return res;
}

int main() {
    //  uncomment the following lines if you want to read/write from files
    //  ifstream cin("input.txt");
    //  ofstream cout("output.txt");

    cin >> N;
    C.resize(N);
    P.resize(N);
    adj.resize(N);
    for (int i = 0; i < N; i++) {
        // node i has color C[i]
        cin >> C[i];
    }
    for (int i = 1; i < N; i++) {
        // there is a link P[i] -> i
        // note: P[0] is undefined!
        cin >> P[i];
        adj[P[i]].push_back(i);
    }

    dfs(0);

    cout << sol << endl;
    return 0;
}
