#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <cstring>

using namespace std;

int N;
string S;

bool test(int K) {
    // assert(S.length() % K == 0);

    int pieces = S.length() / K;
    for (int i = 0; i < pieces / 2; ++i) {
        int found = strncmp(
            S.c_str() + i * K,
            S.c_str() + (pieces - 1 - i) * K,
            K
        );

        if (found != 0) {
            // cerr << "Fail after " << i+1 << " attempts" << endl;
            return false;
        }
    }

    return true;
}

int main() {
    ios::sync_with_stdio(false);
    
    cin >> N;
    cin >> S;

    int sol = N;
    for (int K = 1; K * K <= N; ++K) if (N % K == 0) {
        if (test(K)) {
            sol = K;
            break;
        }
    }
    for (int K = sqrt(N); K >= 1; K--) if (N % K == 0) {
        if (N / K > sol) break;
        if (test(N / K)) {
            sol = min(sol, N / K);
            break;
        }
    }

    cout << sol << endl;
}
